#include <iostream>
#include <algorithm>

using namespace std;

int pakiKott(int maksKaal, int kogus, int* kaalud, int* vaartused)
{
    int** parimad = new int*[maksKaal + 1];
    for (int i = 0; i <= maksKaal; i++) {
        parimad[i] = new int[kogus] {0};
    }

    for (int i = 0; i <= maksKaal; i++) {
        if (kaalud[0] <= i) {
            parimad[i][0] = std::max(parimad[i][0], vaartused[0]);
        }
    }

    int vastus = 0;
    for (int i = 1; i <= maksKaal; i++) {
        for (int j = 1; j < kogus; j++) {
            parimad[i][j] = parimad[i][j - 1];
            if (kaalud[j] <= i) {
                parimad[i][j] =
                    max(parimad[i][j], parimad[i - kaalud[j]][j - 1] + vaartused[j]);
            }
            vastus = max(vastus, parimad[i][j]);
        }
    }
    return vastus;
}


int main()
{
    int kaal, arv;
    cin >> kaal >> arv;

    int* kaalud = new int[arv];
    int* hinnad = new int[arv];
    for (int i = 0; i < arv; i++) {
        cin >> kaalud[i];
        cin >> hinnad[i];
    }

    cout << pakiKott(kaal, arv, kaalud, hinnad) << endl;
    cin >> kaal;
    return 0;
}

