#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

int SmithWaterman(int n, int m, string s, string t)
{
    int** dp = new int*[n+1];
    for (int i = 0; i <= n; i++) {
        dp[i] = new int[m+1];
        for (int j = 0; j <= m; j++) {
            dp[i][j] = 0;
        }
    }

    int vas = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            int sc = -3; // ei lange kokku
            if (s[i-1] == t[j-1]) {
                sc = 3; // langeb kokku
            }
            dp[i][j] = max(max(dp[i - 1][j] - 2, dp[i][j - 1] - 2), max(0, dp[i - 1][j - 1] + sc));
            vas = max(vas, dp[i][j]);
        }
    }
    return vas;
}

int main()
{
    int a, b;
    string A, B;
    cin >> a;
    cin >> A;
    cin >> b;
    cin >> B;
    cout << SmithWaterman(a, b, A, B) << endl;
    return 0;
}
