#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int matMul(int n, vector<int> ml)
{
    int** dp = new int*[n+1];
    for (int i = 0; i <= n; i++) {
        dp[i] = new int[n+1];
    }

    for (int vh = 0; vh <= n; vh++) {// vh - vahed
        for (int i = 1; i + vh <= n; i++) {
            int j = i + vh;
            dp[i][j] = (i == j) ? 0 : 1000000000;
            for (int k = i; k < j; k++)
            {
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k + 1][j] + (ml[i + 1] * ml[k] * ml[j]));
            }
        }
    }
    return dp[1][n];
}

int main()
{
    int n, i;
    cin >> n;
    vector<int> ml;
    for (i = 0; i <= n; i++) {
        int x;
        cin >> x;
        ml.push_back(x);
    }
    cout << matMul(n, ml);
}
